src/medux/plugins/wiki/urls.py
from django.urls import path
from . import views

# namespaced URLs
app_name = "wiki"
urlpatterns = [
    path("", views.ArticleList.as_view(), name="article-list"),
    path("article/add/", views.ArticleCreateView.as_view(), name="article-add"),
    # path(
    #     "article/by_author/<author>/",
    #     views.ArticleByAuthorView.as_view(),
    #     "article-by-author",
    # ),
    path(
        "article/<str:slug>/change/",
        views.ArticleUpdateView.as_view(),
        name="article-update",
    ),
    path("article/<str:slug>/", views.ArticleDetail.as_view(), name="article-detail"),
    path(
        "article/<str:slug>/publish/",
        views.ArticlePublishView.as_view(),
        name="article-publish",
    ),
    path(
        "article/<str:slug>/unpublish/",
        views.ArticleUnPublishView.as_view(),
        name="article-unpublish",
    ),
    path(
        "article/<str:slug>/history/",
        views.ArticleHistoryView.as_view(),
        name="article-history",
    ),
]


# global URLs
root_urlpatterns = [
    # path("api/foo", views.APIView.as_view(), name="api"),
]

src/medux/plugins/wiki/models.py
import reversion
from django.contrib.auth import get_user_model
from django.db import models
from django.template.defaultfilters import slugify
from django.urls import reverse
from django.utils.translation import gettext_lazy as _
from medux.common.models import Tenant, CreatedModifiedModel

User = get_user_model()


class PublishedArticlesManager(models.Manager):
    def get_query_set(self):
        return (
            super(PublishedArticlesManager, self)
            .get_query_set()
            .filter(is_published=True)
        )


@reversion.register()
class Article(CreatedModifiedModel):
    """Represents a wiki article"""

    tenant = models.ForeignKey(Tenant, on_delete=models.CASCADE)
    title = models.CharField(max_length=100)
    slug = models.SlugField(max_length=50, unique=True)
    text = models.TextField(
        help_text="This text will be formatted using <a href='#' tabindex='-1'>MarkDown</a>."  # TODO: add link
    )
    author = models.ForeignKey(User, on_delete=models.CASCADE)
    is_published = models.BooleanField(default=False, verbose_name=_("Publish?"))

    objects = models.Manager()
    published = PublishedArticlesManager()

    def __str__(self):
        return self.title

    def save(self, *args, **kwargs):
        if not self.slug:
            self.slug = slugify(self.title)
        super(Article, self).save(*args, **kwargs)

    def get_absolute_url(self):
        return reverse("wiki:article-detail", kwargs={"slug": self.slug})


class Edit(CreatedModifiedModel):
    """Stores an edit session"""

    article = models.ForeignKey(Article, on_delete=models.CASCADE)
    editor = models.ForeignKey(User, on_delete=models.CASCADE)
    summary = models.CharField(max_length=100)

    class Meta:
        ordering = ["-modified"]

    def __str__(self):
        return f"{self.summary} - {self.editor} - {self.modified}"

    def get_absolute_url(self):
        return ("wiki:edit-detail", self.id)

src/medux/plugins/wiki/forms.py
from crispy_forms.helper import FormHelper
from crispy_forms.layout import Layout, Row, Column, Submit, Button, Div, HTML
from django import forms
from django.utils.translation import gettext_lazy as _
from .models import Article, Edit


class ArticleForm(forms.ModelForm):
    class Meta:
        model = Article
        exclude = ["modified", "author", "slug", "tenant", "is_published"]

    comment = forms.CharField(
        max_length=255, help_text=_("A short summary of what you have changed.")
    )

    def __init__(self, **kwargs):
        super().__init__(**kwargs)
        comment: forms.Field = self.fields["comment"]
        comment.required = True
        # comment.initial =
        self.helper = FormHelper()
        self.helper.add_input(Submit("submit", _("Save")))


class EditForm(forms.ModelForm):
    class Meta:
        model = Edit
        fields = ["summary"]

src/medux/plugins/wiki/views.py
import reversion
from django.contrib import messages
from django.contrib.auth.mixins import PermissionRequiredMixin
from django.contrib.messages.views import SuccessMessageMixin
from django.shortcuts import redirect, get_object_or_404
from django.views.generic import CreateView, ListView, DetailView, UpdateView
from django.utils.translation import gettext_lazy as _
from reversion.models import Version
from reversion.views import RevisionMixin

from .models import Article
from .forms import ArticleForm


class ArticleCreateView(RevisionMixin, CreateView):
    template_name = "wiki/article_form.html"
    form_class = ArticleForm

    def form_valid(self, form):
        article = form.save(commit=False)
        article.author = self.request.user
        article.tenant = self.request.user.tenant
        article.save()
        msg = _("Article saved successfully.")
        messages.success(self.request, msg)
        return redirect(article)


class ArticleUpdateView(RevisionMixin, UpdateView):
    model = Article
    form_class = ArticleForm
    extra_context = {"editing": True}

    def form_valid(self, form):
        article = form.save(commit=False)
        article.save()
        reversion.set_user(self.request.user)
        reversion.set_comment(form.cleaned_data["comment"])
        msg = _("Article saved successfully")
        messages.success(self.request, msg)
        return redirect(article)


class ArticleHistoryView(RevisionMixin, ListView):
    template_name = "wiki/article_history.html"
    extra_context = {"history": True}

    def get_queryset(self):
        self.article = Article.objects.get(slug=self.kwargs.get("slug"))
        return Version.objects.get_for_object(self.article)

    def get_context_data(self, *, object_list=None, **kwargs):
        context = super().get_context_data(object_list=object_list, **kwargs)
        context["article"] = get_object_or_404(Article, slug=self.kwargs.get("slug"))
        context["object_list"] = self.get_queryset()
        return context


class ArticleList(ListView):
    template_name = "wiki/article_list.html"

    def get_queryset(self):
        return Article.objects.all()


class ArticleDetail(DetailView):
    model = Article
    template_name = "wiki/article_detail.html"

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context["last_version"] = Version.objects.get_for_object(self.object).first()
        return context


class ArticleByAuthorView(PermissionRequiredMixin, ListView):
    model = Article
    template_name = "wiki/article_list_by_author"
    permission_required = "wiki.view_article"

    def get_queryset(self):
        return self.model.objects.filter(
            tenant=self.request.user.tenant, author=self.request.user
        )

    def get_context_data(self, *, object_list=None, **kwargs):
        self.author = kwargs.pop("author")
        return super().get_context_data(object_list, **kwargs)


class ArticlePublishView(PermissionRequiredMixin, SuccessMessageMixin, DetailView):
    model = Article
    template_name = "wiki/_publish_button.html"
    permission_required = "wiki.change_article"
    success_message = _("Article published.")

    def post(self, request, *args, **kwargs):
        article = self.get_object()
        article.is_published = True
        article.save()
        return self.render_to_response({"article": article})


class ArticleUnPublishView(PermissionRequiredMixin, SuccessMessageMixin, DetailView):
    model = Article
    template_name = "wiki/_publish_button.html"
    permission_required = "wiki.change_article"
    success_message = _("Article unpublished.")

    def post(self, request, *args, **kwargs):
        article = self.get_object()
        article.is_published = False
        article.save()
        return self.render_to_response({"article": article})

src/medux/plugins/wiki/templates/wiki/_publish_button.html
{% load i18n markdownify %}

{% if article.is_published %}
  <button
      class="btn-action"
      hx-post="{% url 'wiki:article-unpublish' article.slug %}"
      hx-swap="outerHTML"
      title="{% translate 'Unpublish article' %}"
  ><i class="bi bi-eye-slash"></i></button>
{% else %}
  <button
      class="btn-action"
      hx-post="{% url 'wiki:article-publish' article.slug %}"
      hx-swap="outerHTML"
      title="{% translate 'Publish article' %}"
  ><i class="bi bi-upload"></i></button>
{% endif %}

{% if request.htmx %}

<div id="published-badge" hx-swap-oob="innerHTML">
  {% include 'wiki/_published_badge.html' with article=article %}
</div>
{% endif %}

src/medux/plugins/wiki/templates/wiki/_published_badge.html
{% load i18n %}
{% if article.is_published %}
{#  <span class="badge">{% translate 'published' %}</span>#}
{% else %}
  <span class="badge bg-warning">{% translate 'unpublished' %}</span>
{% endif %}

src/medux/plugins/wiki/templates/wiki/article_detail.html
{% extends 'wiki/base.html' %}
{% load i18n markdownify %}

{% block card-title %}{{ article.title }}{% endblock %}

{% block card-actions %}
  {% include 'wiki/_publish_button.html' %}
  {{ block.super }}
{% endblock %}

{% block card-text %}
  {{ article.text|markdownify }}
{% endblock %}

src/medux/plugins/wiki/templates/wiki/article_form.html
{% extends 'wiki/base.html' %}
{% load i18n markdownify crispy_forms_tags %}

{% block card-title %}
  {% if article %}
    {% blocktranslate %}Edit article '{{ article }}'{% endblocktranslate %}
  {% else %}
    {% translate 'Create new article' %}
  {% endif %}
{% endblock %}

{% block card-text %}
  {% crispy form %}
{% endblock %}

src/medux/plugins/wiki/templates/wiki/article_history.html
{% extends 'wiki/base.html' %}
{% load i18n markdownify %}

{% block card-title %}{{ article }} (<span class="small">{% translate 'History' %}</span>){% endblock %}

{% block card-text %}
  <table class="table">
    <thead>
    <tr>
      <th>{% translate 'Edited' %}</th>
      <th>{% translate 'User' %}</th>
      <th>{% translate 'Comment' %}</th>
    </tr>
    </thead>
    <tbody>
    {% for version in object_list %}
      <tr>
        <td>{{ version.revision.date_created }}</td>
        <td>{{ version.revision.user }}</td>
        <td>{{ version.revision.comment }}</td>
      </tr>
    {% endfor %}
    <tr>
      <td>{{ article.created_on }}</td>
      <td>{{ article.author }}</td>
      <td>{% translate 'New article created.' %}</td>
    </tr>
    </tbody>
  </table>
{% endblock %}

{% block card_footer %}
  {% if article %}
    <a class="btn" href="{% url 'wiki:article-detail' article.slug %}"><< Back</a>
  {% endif %}
{% endblock %}

src/medux/plugins/wiki/templates/wiki/article_list.html
{% extends 'wiki/base.html' %}
{% load i18n %}

{% block content %}
  <div class="container-fluid p-2">
    <div class="row">
      <div class="col-12 col-md-9">
        <div class="card">
          <div class="card-body">
            Start page...
          </div>
        </div>
      </div>
      <div class="col d-none d-md-block col-md-3">
        <div class="card">
          <div class="card-body">
            {% if object_list %}
              <h2 class="card-title">{% translate 'Recent Articles' %}</h2>
              <ul>
                {% for article in object_list %}
                  <li>
                    <a href="{% url 'wiki:article-detail' article.slug %}">{{ article.title }}</a>
                  </li>
                {% endfor %}
              </ul>
            {% else %}
              <h2 class="card-title">{% translate 'No articles have been published yet.' %}</h2>
              <p class="card-text"><a class="btn" href="{% url 'wiki:article-add' %}">{% translate 'Create new article' %}</a></p>
            {% endif %}
          </div>
        </div>
      </div>
    </div>
  </div>
{% endblock %}

src/medux/plugins/wiki/templates/wiki/base.html
{% extends 'core/base.html' %}
{% load i18n %}

{% block sidebar-content %}
  TODO: Menu
{% endblock %}

{% block content %}
  <div class="card position-relative">
    <span id="published-badge" class="position-absolute top-0 start-50 translate-middle">
      {% include 'wiki/_published_badge.html' with article=article %}
    </span>

    <div class="card-header">
      {% block card-header %}
        <h3 class="card-title">
          {% block card-title %}{% endblock %}
        </h3>
      {% endblock %}

      <div class="card-actions btn-actions">
        {% block card-actions %}
        {% if article %}
          {% if editing or history %}
            <button
                id="action-article-show"
                class="btn-action"
                title="{% translate 'Show article' %}"
                hx-get="{% url 'wiki:article-detail' article.slug %}"
                hx-target="#page-wrapper"
                hx-select="#page-wrapper"
                hx-swap="outerHTML"
                hx-push-url="{% url 'wiki:article-detail' article.slug %}"
            >
              <i class="bi bi-file-text"></i>
            </button>
          {% else %}
            <button
                id="action-article-update"
                class="btn-action"
                title="{% translate 'Edit article' %}"
                hx-get="{% url 'wiki:article-update' article.slug %}"
                hx-target="#page-wrapper"
                hx-select="#page-wrapper"
                hx-swap="outerHTML"
                hx-push-url="{% url 'wiki:article-update' article.slug %}"
            >
              <i class="bi bi-pencil"></i>
            </button>
          {% endif %}
          <button
              id="action-article-history"
              class="btn-action"
              {% if history %}
              disabled
              {% else %}
              hx-get="{% url 'wiki:article-history' article.slug %}"
              hx-target="#page-wrapper"
              hx-select="#page-wrapper"
              hx-swap="outerHTML"
              hx-push-url="{% url 'wiki:article-history' article.slug %}"
              {% endif %}
              title="{% translate 'View article history' %}"
          >
            <i class="bi bi-clock-history"></i>
          </button>
        {% endif %}
      {% endblock %}
      </div>
    </div>
    <div id="article-body" class="card-body">
      {% block card-text %}{% endblock %}
    </div>
    <div class="card-footer">
      {% block card_footer %}
        <ul class="list-inline list-inline-dots mb-0">
          {% if article %}
            <li class="list-inline-item small">{% translate 'Author' %}: <a href="{# {% url 'wiki:article-by-author' %}#}" class="link-secondary">{{ article.author }}</a></li>
            <li class="list-inline-item small">
              {% translate 'Last edited' %}: <a href="{% url 'wiki:article-history' article.slug %}">{{ last_version.revision.date_created }}</a> {% translate 'by' %} {{ last_version.revision.user }}</li>
          {% endif %}
        </ul>
      {% endblock %}
    </div>
  </div>
{% endblock %}